;*H***************************************************************************
; NAME: stc15f204ea.inc           
;----------------------------------------------------------------------------
; PURPOSE: SFR Description file for STC15F204EA products on C51ASM assembler
;*****************************************************************************

$SAVE    
$NOLIST 
$NOMOD51

 .equ restt = 0x0000 ; / 
 .equ int0ir = 0x0003 ; INT0
 .equ tim0ir = 0x000B ; T/C0
 .equ int1ir = 0x0013 ; INT1
 .equ tim1ir = 0x001B ; T/C1
; .equ rt1ir = 0x0023 ;  UART   
                  ; No S1(UART1)  
 .equ adcir = 0x002B ; ADC
 .equ lvdir = 0x0033 ; LVD
; .equ pcair = 0x003B ; No PCA  
; .equ rt2ir = 0x0043 ; No S2(UART2)  
; .equ spiir = 0x004B ; No SPI  
 .equ int2ir = 0x0053 ; /INT2
 .equ int3ir = 0x005B ; /INT3
; .equ brtir = 0x0063 ; No BRT_INT  
; .equ ??? = 0x006B ; reserved
; .equ srzir0 = 0x0073 ; System Reserved  
; .equ srzir1 = 0x007B ; System Reserved  
 .equ int4ir = 0x0083 ; /INT4
 .equ end_irrez = 0x008B
 .equ int_vectors_syze = 0x008F
 .equ ram_start = 0x0030
 .equ steck_start = 0x007F
 .equ ramend = 0x007F
 .equ steckend = 0x00FF
 .equ rom_end = 0x0FFF
 .equ eeprom_end = 0x03FF
 .equ sector_size = 512 ; 0x1FF

;-------------------------------------------------
;  PORT Registers  


;   Table: Configuration of I/O port mode.
;  PxM1.n | PxM0.n |     Port Mode
;  PxM1_n | PxM0_n |
;    0    |   0    | Quasi-bidirectional
;    0    |   1    | Push-Pull output
;    1    |   0    | Input Only (High-impedance)
;    1    |   1    | Open-Drain Output
; where x = 0 ~ 3 (port number), and n = 0 ~7 (port pin).


P0    DATA 080H        

; P0_7  BIT  087H ;   
; P0_6  BIT  086H ;   
; P0_5  BIT  085H ;   
; P0_4  BIT  084H ;   
; P0_3  BIT  083H ;   
; P0_2  BIT  082H ;   
P0_1    BIT  081H
P0_0    BIT  080H
RSTpin  BIT  0x80 ;   RST
SYSclkO BIT  0x80

P0M1  DATA 0x93

P0M1_1  equ 1
P0M1_0  equ 0

P0M0  DATA 0x94

P0M0_1  equ 1
P0M0_0  equ 0

;------------------------

P1    DATA 090H   
     
P1_7  BIT  097H
P1_6  BIT  096H
P1_5  BIT  095H
P1_4  BIT  094H
P1_3  BIT  093H
P1_2  BIT  092H
P1_1  BIT  091H
P1_0  BIT  090H
ADC7  BIT  0x97
ADC6  BIT  0x96
ADC5  BIT  0x95
ADC4  BIT  0x94
ADC3  BIT  0x93
ADC2  BIT  0x92
ADC1  BIT  0x91
ADC0  BIT  0x90

P1M1  DATA 0x91

P1M1_7  equ  7
P1M1_6  equ  6
P1M1_5  equ  5
P1M1_4  equ  4
P1M1_3  equ  3
P1M1_2  equ  2
P1M1_1  equ  1
P1M1_0  equ  0

P1M0  DATA 0x92

P1M0_7  equ  7
P1M0_6  equ  6
P1M0_5  equ  5
P1M0_4  equ  4
P1M0_3  equ  3
P1M0_2  equ  2
P1M0_1  equ  1
P1M0_0  equ  0

;------------------------

P2    DATA 0A0H 
  
P2_7  BIT  0A7H
P2_6  BIT  0A6H
P2_5  BIT  0A5H
P2_4  BIT  0A4H
P2_3  BIT  0A3H
P2_2  BIT  0A2H
P2_1  BIT  0A1H
P2_0  BIT  0A0H
RSTOUT_LOW BIT 0xA0 ;     0 ???
          ; "... After power-up, it will output 0. 
					; Change the output register to 1 before 
          ; making it iuput ..."


P2M1  DATA 0x95

P2M1_7  equ  7
P2M1_6  equ  6
P2M1_5  equ  5
P2M1_4  equ  4
P2M1_3  equ  3
P2M1_2  equ  2
P2M1_1  equ  1
P2M1_0  equ  0

P2M0  DATA 0x96

P2M0_7  equ  7
P2M0_6  equ  6
P2M0_5  equ  5
P2M0_4  equ  4
P2M0_3  equ  3
P2M0_2  equ  2
P2M0_1  equ  1
P2M0_0  equ  0

;------------------------

P3    DATA 0B0H        

P3_7  BIT  0B7H
P3_6  BIT  0B6H
P3_5  BIT  0B5H
P3_4  BIT  0B4H
P3_3  BIT  0B3H
P3_2  BIT  0B2H
P3_1  BIT  0B1H
P3_0  BIT  0B0H
;RD    BIT  0B7H ;   
;WR    BIT  0B6H ;   
INT3     BIT  0B7H
INT2     BIT  0B6H
T1       BIT  0B5H
CLKOUT0  BIT  0B5H
T0       BIT  0B4H
CLKOUT1  BIT  0B4H
INT1     BIT  0B3H
INT0     BIT  0B2H
;TXD   BIT  0B1H ;   
;  
;RXD   BIT  0B0H ;   
;  
INT4     BIT  0B0H

P3M1  DATA 0xB1

P3M1_7  equ  7
P3M1_6  equ  6
P3M1_5  equ  5
P3M1_4  equ  4
P3M1_3  equ  3
P3M1_2  equ  2
P3M1_1  equ  1
P3M1_0  equ  0

P3M0  DATA 0xB2

P3M0_7  equ  7
P3M0_6  equ  6
P3M0_5  equ  5
P3M0_4  equ  4
P3M0_3  equ  3
P3M0_2  equ  2
P3M0_1  equ  1
P3M0_0  equ  0

;------------------ Status register ---------------------
PSW  DATA 0D0H       

CY   BIT  0D7H
AC   BIT  0D6H
F0   BIT  0D5H
RS1  BIT  0D4H
RS0  BIT  0D3H
OV   BIT  0D2H
;   BIT  0D1H ;   , reserved
P    BIT  0D0H

;------------------ CPU registers ---------------------
ACC  DATA 0E0H       
B    DATA 0F0H 
SP   DATA 081H        
DPL  DATA 082H       
DPH  DATA 083H 

;------------------ TIMERS registers ---------------------
TCON DATA 088H
TF1  BIT  08FH
TR1  BIT  08EH
TF0  BIT  08DH
TR0  BIT  08CH
IE1  BIT  08BH
IT1  BIT  08AH
IE0  BIT  089H
IT0  BIT  088H
       
TMOD DATA 089H

GATE_1    equ  7
CnotT_1   equ  6 ; C/T
M1_1      equ  5
M1_0      equ  4
GATE_0    equ  3
CnotT_0   equ  2 ; C/T
M0_1      equ  1
M0_0      equ  0

;  Mx_1 |  Mx_0 |   (x=0 OR 1)        Operating Mode 
;   0   |   0   | 16-bit auto-reload Timer/Counter for Timer 0 and Timer 1
;   0   |   1   | 16-bit Timer/Counter"THx"and"TLx"are cascaded;there is no prescaler
;   1   |   0   | 8-bit auto-reload Timer/Counter THx 
;       |       |    holds a value which is to be reloaded into TLx 
;       |       |   each time it overflows.
;   1   |   1   |  (Timer 0) TL0 is an 8-bit Timer/Counter controlled by
;       |       |    the standard Timer 0 control bits 
;       |       |   TH0 is an 8-bit timer only controlled by Timer 1 control bits.
;   1   |   1   |  (Timer 1) Timer/Counter 1 stopped

TL0  DATA 08AH       
TL1  DATA 08BH       
TH0  DATA 08CH       
TH1  DATA 08DH


AUXR DATA  08EH

T0x12 equ 7 ; T0x12 = 0 The clock source of Timer 0 is Fosc/12.
             ; T0x12 = 1 The clock source of Timer 0 is Fosc.
T1x12 equ 6 ; T1x12 = 0 The clock source of Timer 1 is Fosc/12.
             ; T1x12 = 1 The clock source of Timer 1 is Fosc.


INT_CLKO  DATA 0x8F

EX4      equ 6 ; External interrupt 4 enable bit (0=disable, 1=enable)
EX3      equ 5 ; External interrupt 3 enable bit (0=disable, 1=enable)
EX2      equ 4 ; External interrupt 2 enable bit (0=disable, 1=enable)
T1CLKO   equ 1 ; When set, P3.4 is enabled to be the clock output of Timer 1.
                ; The clock rate is Timer 1 overflow rate divided by 2.
T0CLKO   equ 0 ; When set, P3.5 is enabled to be the clock output of Timer 0.
                ; The clock rate is Timer 0 overflow rate divided by 2.

    

;-------------------- IT registers -----------------------
IE   DATA  0A8H      
IP   DATA  0B8H      

;  IE  
EA    BIT 0AFH
ELVD  BIT 0xAE
EADC  BIT 0xAD
EX1   BIT 0AAH
ET0   BIT 0A9H
EX0   BIT 0A8H

;  IP  
PLVD BIT 0xBE
PADC BIT 0xBD
PT1  BIT 0BBH
PX1  BIT 0BAH
PT0  BIT 0B9H
PX0  BIT 0B8H

;-------------------- OSC control registers ----------------------
PCON  DATA 087H      

LVDF   equ 5 ;
POF    equ 4 ;
GF1    equ 3 ;
GF0    equ 2 ;
PD     equ 1 ;
IDL    equ 0 ;


CLK_DIV  DATA 0x97

CLKS2  equ 2
CLKS1  equ 1
CLKS0  equ 0
;{CLKS2,CLKS1,CLKS0}
;000 := The internal RC oscillator is set as the clock-in not divided (default state)
;001 := The internal RC oscillator is set as the clock-in divided by 2
;010 := The internal RC oscillator is set as the clock-in divided by 4
;011 := The internal RC oscillator is set as the clock-in divided by 8
;100 := The internal RC oscillator is set as the clock-in divided by16
;101 := The internal RC oscillator is set as the clock-in divided by 32
;110 := The internal RC oscillator is set as the clock-in divided by 64
;111 := The internal RC oscillator is set as the clock-in divided by 128


IRC_CLKO  DATA 0xBB

EN_IRCO  equ 7
DIVIRCO  equ 3
; Set EN_IRCO(IRC_CLKO.7) to switch P0.0 into IRC clock output pin.
; Depending on DIVIRCO set or clear, the 
; output frequency will be SYSclk/2 or SYSclk.

;-------------------- WDT control registers ----------------------

WDT_CONTR  DATA 0xC1

WDT_FLAG  equ 7 ; WDT reset flag.
                 ;  0   :   This bit should be cleared by software.
                 ;  1   :   When WDT overflows, this bit is set 
					       ;		by hardware to indicate a WDT reset happened.
EN_WDT    equ 5 ; Enable WDT bit. When set, WDT is started.
CLR_WDT   equ 4 ; WDT clear bit. When set, WDT will recount.
                 ; Hardware will automatically clear this bit.
IDLE_WDT  equ 3 ; WDT IDLE mode bit. When set, WDT is enabled in IDLE mode.
                 ; When clear, WDT is disabled in IDLE
PS2       equ 2
PS1       equ 1
PS0       equ 0

;PS2, PS1, PS0 - WDT Pre-scale value set bit.
;Pre-scale value of Watchdog timer is shown as the bellowed table :
; PS2 PS1 PS0  Pre-scale  WDT overflow Time  @20MHz
;  0   0   0       2           39.3 mS
;  0   0   1       4           78.6 mS
;  0   1   0       8          157.3 mS
;  0   1   1      16          314.6 mS
;  1   0   0      32          629.1 mS
;  1   0   1      64           1.25 S
;  1   1   0     128           2.5 S
;  1   1   1     256             5 S
; The WDT overflow time is determined by the following equation:
;  WDT overflow time = (12 * Pre-scale * 32768) / SYSclk

;-------------------- ADC control registers ----------------------

P1ASF   DATA  0x9D

P17ASF  equ  7 ; P1NASF=0   (N= )
P16ASF  equ  6 ; P1NASF=1   (N= )
P15ASF  equ  5
P14ASF  equ  4
P13ASF  equ  3
P12ASF  equ  2
P11ASF  equ  1
P10ASF  equ  0


ADC_CONTR  DATA 0xBC

ADC_POWER   equ 7 ; When clear shut down the power of ADC block.
                   ; When set turn on the power of ADC block
SPEED1      equ 6
SPEED0      equ 5
; SPEED1, SPEED0 : Conversion speed selection.
;   00   :   540  clock cycles are needed for a conversion.
;   01   :   360  clock cycles are needed for a conversion.
;   10   :   180  clock cycles are needed for a conversion.
;   11   :    90  clock cycles are needed for a conversion.
ADC_FLAG    equ 4 ; ADC interrupt flag.It will be set by the device
                   ; after the device has finished a conversion, and    
                   ; should be cleared by the user's software.
ADC_START   equ 3 ; ADC start bit, which enable ADC conversion.
                   ; It will automatically cleared by the device after the  
                   ; device has finished the conversion.
CHS2        equ 2
CHS1        equ 1
CHS0        equ 0
;Used to select one analog input source from 8 channels.
;  CHS2  CHS1  CHS0             Source
;   0     0     0    P1.0 (default) as the A/D channel input
;   0     0     1    P1.1 as the A/D channel input
;   0     1     0    P1.2 as the A/D channel input
;   0     1     1    P1.3 as the A/D channel input
;   1     0     0    P1.4 as the A/D channel input
;   1     0     1    P1.5 as the A/D channel input
;   1     1     0    P1.6 as the A/D channel input
;   1     1     1    P1.7 as the A/D channel input

ADC_RES   DATA 0xBD ;  

ADC_RESL  DATA 0xBE ;   

;-------------------- ISP/IAP control registers ----------------------

IAP_DATA   DATA 0xC2 ; IAP_DATA is the data port register for ISP/IAP operation.
                     ; The data in IAP_DATA will be written into 
                     ; the desired address in operating ISP/IAP write and it is
										 ; the data window of readout in operating ISP/IAP read.
										 
IAP_ADDRH  DATA 0xC3 ; IAP_ADDRH is the high-byte address port for all ISP/IAP modes.
                     ; IAP_ADDRH[7:5] must be cleared to 000, 
										 ; if one bit of IAP_ADDRH[7:5] is set, the IAP/ISP write 
                     ; function must fail.
                     
IAP_ADDRL  DATA 0xC4 ; IAP_ADDRL is the low port for all ISP/IAP modes.
                     ; In page erase operation, it is ignored.
                     
IAP_CMD    DATA 0xC5 ; ISP/IAP Flash-operating Mode Command Register

MS1    equ 1
MS0    equ 0
;          ISP/IAP operating mode selection. 
;  IAP_CMD is used to select the flash mode for    
; MS1  MS0  performing numerous ISP/IAP function or used to access protected SFRs.
;  0    0   Standby
;  0    1   Data Flash/EEPROM read.
;  1    0   Data Flash/EEPROM program.
;  1    1   Data Flash/EEPROM page erase

IAP_TRIG   DATA 0xC6 ; IAP_TRIG is the command port for triggering ISP/IAP
                     ; activity and protected SFRs access. If IAP_TRIG is filled 
                     ; with sequential 0x5Ah, 0xA5h and if IAPEN(IAP_CONTR.7) = 1,
										 ; ISP/IAP activity or protected SFRs access will triggered.

IAP_CONTR  DATA 0xC7 ; ISP/IAP Control Register

IAPEN    equ 7 ;  ISP/IAP operation enable. 
                ;  0 :  Global disable all ISP/IAP program/erase/read function. 
                ;  1 :  Enable ISP/IAP program/erase/read function.
SWBS     equ 6 ;  software boot selection control. 
                ;  0 :  Boot from main-memory after reset. 
                ;  1 :  Boot from ISP memory after reset.   
SWRST    equ 5 ;  software reset trigger control. 
                ;  0 :  No operation 
                ;  1 :  Generate software system reset.
						  	; It will be cleared by hardware automatically.
CMD_FAIL equ 4 ; Command Fail indication for ISP/IAP operation. 
                ;  0 :  The last ISP/IAP command has finished successfully. 
                ;  1 :  The last ISP/IAP command fails.
								; It could be caused since the access of flash memory was inhibited. 
; BYT3   equ 3 ; Reserved. Software must write 0 on this bit when IAP_CONTR is written. 
WT2   equ 2
WT1   equ 1
WT0   equ 0
;Waiting time selection while flash is busy. 
;Setting wait times CPU wait times
; WT2 WT1 WT0     Read         Program     Sector Erase    Recommended System 
;              (2 SYSclks)      =55uS         =21mS        Clock Frequency (MHz)
;  1   1   1    2 SYSclks     55 SYSclks   21012 SYSclks       < 1MHz
;  1   1   0    2 SYSclks    110 SYSclks   42024 SYSclks       < 2MHz
;  1   0   1    2 SYSclks    165 SYSclks   63036 SYSclks       < 3MHz
;  1   0   0    2 SYSclks    330 SYSclks   126072 SYSclks      < 6MHz
;  0   1   1    2 SYSclks    660 SYSclks   252144 SYSclks      < 12MHz
;  0   1   0    2 SYSclks   1100 SYSclks   420240 SYSclks      < 20MHz
;  0   0   1    2 SYSclks   1320 SYSclks   504288 SYSclks      < 24MHz
;  0   0   0    2 SYSclks   1760 SYSclks   672384 SYSclks      < 30MHz
;
; Note: Software reset actions could reset other SFR,
; but it never influences bits IAPEN and SWBS.
; The IAPEN and SWBS. The IAPEN and SWBS only will
; be reset by power-up action, while not software reset.

$RESTORE